﻿unit KDSFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, Grids, StdCtrls, ExtCtrls, POSButtons, Buttons, pngimage;

type
  TFramKDS = class(TFrame)
    plf: TPanel;
    Panel1: TPanel;
    imgNOK: TImage;
    imgOK: TImage;
    StringGrid1: TStringGrid;
    Panel2: TPanel;
    lb1: TLabel;
    lb2: TLabel;
    lb3: TLabel;
    lb4: TLabel;
    lb5: TLabel;
    lb0: TLabel;
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);

  private
    { Private declarations }
  public
    FBtn : Array of TSpeedButton;
    FWindows:String;
    { Public declarations }
  end;

implementation

{$R *.dfm}


uses KDSClient;


procedure TFramKDS.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  uFmt : Cardinal;
  mStr:string;
begin

  //gdFixed(固定行または固定列)の場合
  with Sender as TStringGrid do
  begin
    { TODO : 畫圖開始 }

    //畫上按鈕
    if (ACol = 2) then
    begin
      if ARow > High(FBtn)  then
      begin
        if Cells[ACol, ARow] <> ''  then
        begin
          SetLength(FBtn, ARow+1);

          if not Assigned(FBtn[ARow]) then
          begin
            FBtn[ARow] := TSpeedButton.Create(nil);
            with FBtn[ARow] do
            begin
              Tag     := ARow;                //識別是哪個Row
              Parent  := TStringGrid(Sender);
              Flat    := True;                //無按鈕樣式
              OnClick := KDSF.GotoKDSService;
              if Cells[ACol, ARow] = 'N'  then
                Glyph.Assign(imgNOK.Picture.Graphic) //指定圖示
              else
                Glyph.Assign(imgOK.Picture.Graphic); //指定圖示
              SetBounds(Rect.Left, Rect.Top, Rect.Right-Rect.Left, Rect.Bottom-Rect.Top); //塞在Cell裡面
            end;
          end;
        end;
      end else
      if ARow < High(FBtn) then
      begin
        if Cells[ACol, ARow] <> ''  then
        begin
          if AROW <> FBtn[AROW].tag then
          begin
            with FBtn[ARow] do
            begin
              Tag := ARow;

              if Cells[ACol, ARow] = 'N'  then
                Glyph.Assign(imgNOK.Picture.Graphic) //指定圖示
              else
                Glyph.Assign(imgOK.Picture.Graphic); //指定圖示
              SetBounds(Rect.Left, Rect.Top, Rect.Right-Rect.Left, Rect.Bottom-Rect.Top); //塞在Cell裡面
            end;
          end;
        end else
        begin
          FBtn[ARow].Glyph := Nil ;
          FBtn[ARow].Free;
        end;
      end;
    end;

    Canvas.FillRect(Rect);
    //設定固定列
    if (gdFixed In State) then begin
      //指定對齊
      uFmt := DT_CENTER or DT_SINGLELINE or DT_VCENTER;
      (Sender as Tstringgrid).Canvas.Brush.color := $004D81FF;
      (Sender as Tstringgrid).Canvas.Font.Color := clWhite;
      Canvas.FillRect(Rect);
      DrawText(Canvas.Handle, PChar(Cells[ACol, ARow]), -1, Rect, uFmt);
    end else
    if (gdSelected   in State) then
    begin
      //取消討厭的駐點底色
      if (ARow mod 2) = 0 then //要改成你自已要的！
        (Sender as Tstringgrid).Canvas.Brush.Color := $00CEDFFB
      else
        (Sender as Tstringgrid).Canvas.Brush.Color := $00ffffff;
        Canvas.FillRect(Rect);
//       (Sender as Tstringgrid).Canvas.Font.Color := $00f3f6ff ;
       (Sender as Tstringgrid).Canvas.Font.Color := $00292D3A ;
        uFmt := DT_Left or DT_SINGLELINE or DT_VCENTER;

      //兩端間隙10pt
      OffsetRect(Rect, 10, 0);

      if ACol = 2  then
      begin
        (Sender as Tstringgrid).Canvas.TextOut(rect.Left, rect.Top, '  ');
      end else
      begin
        DrawText(Canvas.Handle, PChar(Cells[ACol, ARow]), -1, Rect, uFmt);
      end;
    end else
    begin
       if (ARow mod 2) = 0 then //要改成你自已要的！
          (Sender as Tstringgrid).Canvas.Brush.Color := $00CEDFFB
        else
          (Sender as Tstringgrid).Canvas.Brush.Color := $00ffffff;


      if (gdSelected in State) then
      begin
        Canvas.Brush.Color:= $008795BA ;
        Canvas.Font.Color := $00f3f6ff ;
      end;
      Canvas.FillRect(Rect);

      //兩端間隙10pt
      OffsetRect(Rect, 10, 0);
      //指定對齊
      uFmt := DT_Left or DT_SINGLELINE or DT_VCENTER;

      if ACol = 2  then
      begin
        (Sender as Tstringgrid).Canvas.TextOut(rect.Left , rect.Top, '  ');
      end else
      begin
        DrawText(Canvas.Handle, PChar(Cells[ACol, ARow]), -1, Rect, uFmt);
      end;
    end;

  end;

end;

end.
